    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------
    028     * XYIntervalDataItem.java
    029     * -----------------------
    030     * (C) Copyright 2006, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: XYIntervalDataItem.java,v 1.1.2.1 2006/10/20 15:23:22 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 20-Oct-2006 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.data.xy;
    044
    045    import org.jfree.data.ComparableObjectItem;
    046
    047    /**
    048     * An item representing data in the form (x, x-low, x-high, y, y-low, y-high).
    049     *
    050     * @since 1.0.3
    051     */
    052    public class XYIntervalDataItem extends ComparableObjectItem {
    053
    054        /**
    055         * Creates a new instance of <code>XYIntervalItem</code>.
    056         *
    057         * @param x  the x-value.
    058         * @param xLow  the lower bound of the x-interval.
    059         * @param xHigh  the upper bound of the x-interval.
    060         * @param y  the y-value.
    061         * @param yLow  the lower bound of the y-interval.
    062         * @param yHigh  the upper bound of the y-interval.
    063         */
    064        public XYIntervalDataItem(double x, double xLow, double xHigh, double y,
    065                double yLow, double yHigh) {
    066            super(new Double(x), new XYInterval(xLow, xHigh, y, yLow, yHigh));
    067        }
    068
    069        /**
    070         * Returns the x-value.
    071         *
    072         * @return The x-value (never <code>null</code>).
    073         */
    074        public Double getX() {
    075            return (Double) getComparable();
    076        }
    077
    078        /**
    079         * Returns the y-value.
    080         *
    081         * @return The y-value.
    082         */
    083        public double getYValue() {
    084            XYInterval interval = (XYInterval) getObject();
    085            if (interval != null) {
    086                return interval.getY();
    087            }
    088            else {
    089                return Double.NaN;
    090            }
    091        }
    092
    093        /**
    094         * Returns the lower bound of the x-interval.
    095         *
    096         * @return The lower bound of the x-interval.
    097         */
    098        public double getXLowValue() {
    099            XYInterval interval = (XYInterval) getObject();
    100            if (interval != null) {
    101                return interval.getXLow();
    102            }
    103            else {
    104                return Double.NaN;
    105            }
    106        }
    107
    108        /**
    109         * Returns the upper bound of the x-interval.
    110         *
    111         * @return The upper bound of the x-interval.
    112         */
    113        public double getXHighValue() {
    114            XYInterval interval = (XYInterval) getObject();
    115            if (interval != null) {
    116                return interval.getXHigh();
    117            }
    118            else {
    119                return Double.NaN;
    120            }
    121        }
    122
    123        /**
    124         * Returns the lower bound of the y-interval.
    125         *
    126         * @return The lower bound of the y-interval.
    127         */
    128        public double getYLowValue() {
    129            XYInterval interval = (XYInterval) getObject();
    130            if (interval != null) {
    131                return interval.getYLow();
    132            }
    133            else {
    134                return Double.NaN;
    135            }
    136        }
    137
    138        /**
    139         * Returns the upper bound of the y-interval.
    140         *
    141         * @return The upper bound of the y-interval.
    142         */
    143        public double getYHighValue() {
    144            XYInterval interval = (XYInterval) getObject();
    145            if (interval != null) {
    146                return interval.getYHigh();
    147            }
    148            else {
    149                return Double.NaN;
    150            }
    151        }
    152
    153    }